// version 0.1
// 2007-01-18
// Copyright (c) 2007, Matej Cepl mcepl at redhat dot com
// Released under the MIT/X11 license
// http://www.opensource.org/licenses/mit-license.php
//
// ==UserScript==
// @name          Bugzilla owner to CC-list
// @namespace     http://www.ceplovi.cz/matej/progs/scripts
// @description   add owner to CC list
// @include https://bugzilla.redhat.com/show_bug.cgi*
// ==/UserScript==
// https://bugzilla.redhat.com/show_bug.cgi?id=451951

var noTriageString = "There is nothing to triage here.\n\n"+
"Switching to ASSIGNED so that developers have responsibility to do whatever "+
"they want to do with it.";

var getLogsString = "Thanks for the bug report.  We have reviewed the information you "+
"have provided above, and there is some additional information we "+
"require that will be helpful in our diagnosis of this issue.\n\n"+
"Please attach your X server config file (/etc/X11/xorg.conf, if available) and "+
"X server log file (/var/log/Xorg.*.log) to the bug report as "+
"individual uncompressed file attachments using the bugzilla file "+
"attachment link below.\n\n"+
"Could you please also try to run without any /etc/X11/xorg.conf (if you have one) "+
"whatsoever and let X11 autodetect your display and video card? "+
"Attach to this bug /var/log/Xorg.0.log from this attempt as well, "+
"please.\n\n"+
"We will review this issue again once you've had a chance to "+
"attach this information.\n\n"+
"Thanks in advance.";

var getLogsLiveCDString = "Thanks for the bug report.  We have reviewed the information you "+
"have provided above, and there is some additional information we "+
"require that will be helpful in our diagnosis of this issue.\n\n"+
"When the anaconda crashes, please, switch to the console (Ctrl+Alt+F2) "+
"and cp /tmp/X* to some other place -- USB stick, some other computer "+
"via network, some on the Internet, and please attach it to the bug report as "+
"individual uncompressed file attachments using the bugzilla file "+
"attachment link below.\n\n"+
"We will review this issue again once you've had a chance to "+
"attach this information.\n\n"+
"Thanks in advance.";

var getFirefoxBacktraceString = "Thanks for the bug report.  We have "+
"reviewed the information you have provided above, and there is "+
"some additional information we require that will be helpful in "+
"our diagnosis of this issue.\n\n"+
"First of all, could we get output of the command\n\n"+
"\trpm -qa \*xulrun\* \*firefox\* \*mozilla\* \*flash\* \*plugin\*\n\n"+
"Please also install firefox-debuginfo (debuginfo-install is from\n"+
"yum-utils package).\n\n"+
"\tdebuginfo-install firefox\n\n"+
"Then run firefox with a parameter -g. That will start firefox "+
"running inside of gdb debugger. Then use command run and do "+
"whatever you did to make firefox crash. When it happens, you "+
"should go back to the gdb and run\n\n"+
"\t(gdb) thread apply all backtrace\n\n"+
"This produces usually many screens of the text. Copy all of them "+
"into a text editor and attach the file to the bug as an "+
"uncompressed attachment.\n\n"+
"We will review this issue again once you've had a chance to "+
"attach this information.\n\n"+
"Thanks in advance.";

var getSuicideString = "If this issue turns out to still be "+
"reproduceable in the latest updates for this Fedora Core release, "+
"please file a bug report in the the upstream bugzilla located at "+
"http://bugzilla.mozilla.org in the particular component.\n\n"+
"Once you've filed your bug report to the upstream bugzilla, if "+
"you paste the new bug URL here, Red Hat will continue to track "+
"the issue in the centralized upstream bug tracker, and will "+
"review any bug fixes that become available for consideration in "+
"future updates.\n\n"+
"Setting status to NEEDINFO, and awaiting upstream bug report URL "+
"for tracking.\n\n"+
"Thanks in advance.";

var noResponseString = "Since there are insufficient details "+
"provided in this report for us to investigate the issue further, "+
"and we have not received feedback to the information we have "+
"requested above, we will assume the problem was not reproducible, "+
"or has been fixed in one of the updates we have released for the "+
"reporter's distribution.\n\n"+
"Users who have experienced this problem are encouraged to upgrade "+
"to the latest update of their distribution, and if this issue turns "+
"out to still be reproducible in the latest update, please reopen this "+
"bug with additional information.\n\n"+
"Closing as INSUFFICIENT_DATA.";

var sentUpstreamString = "We filed this bug in the upstream database "+
"() and believe that it is more appropriate to let it be resolved "+
"upstream.\n\n"+
"Red Hat will continue to track the issue in the centralized "+
"upstream bug tracker, and will review any bug fixes that become "+
"available for consideration in future updates.\n\n"+
"Thank you for the bug report.";

var moveYourButString = "Reporter, could you please reply to the "+
"previous question? If you won't reply in one month, I will have to "+
"close this bug as INSUFFICIENT_DATA. Thank you.";

var RHELString = "For official Red Hat Enterprise Linux support, please "+
"log into the Red Hat support website at http://www.redhat.com/support and "+
"file a support ticket. To understand how your bug is tracked through our "+
"system, please see https://www.redhat.com/support/process/production/#howrh";

var dieNvidiaDieDieDie = "Thanks for the report. We are sorry "+
"that we cannot help you with your problem, but we are not able to "+
"support binary-only drivers. If you would be able to reproduce "+
"this issue using only open source software, please, reopen this "+
"bug with the additional information, but in meantime I have no "+
"choice than to close this bug as CANTFIX (because we really "+
"cannot fix it).\n\n"+
"For users who are experiencing problems installing, configuring, "+
"or using the unsupported 3rd party proprietary \"nvidia\" video "+
"driver, Nvidia provides indirect customer support via an "+
"online web based support forum.  Nvidia monitors these web "+
"forums for commonly reported problems and passes them on to "+
"Nvidia engineers for investigation.  Once they've isolated "+
"a particular problem, it is often fixed in a future video "+
"driver update.\n\n"+
"The NVNews Nvidia Linux driver forum is located at:\n\n"+
"    http://www.nvnews.net/vbulletin/forumdisplay.php?s=&forumid=14\n\n"+
"Once you have reported this issue in the Nvidia web forums, "+
"others who may have experienced the particular problem may "+
"be able to assist.  If there is a real bug occuring, Nvidia "+
"will be able to determine this, and will likely resolve the "+
"issue in a future driver update for the operating system "+
"releases that they officially support.\n\n"+
"While Red Hat does not support the proprietary nvidia driver, "+
"users requiring technical support may also find the various "+
"X.Org, XFree86, and Red Hat mailing lists helpful in "+
"finding assistance:\n\n"+
"X.Org mailing lists:\n"+
"    http://www.freedesktop.org/XOrg/XorgMailingLists\n\n"+
"XFree86 mailing lists:\n"+
"    http://www.xfree86.org/sos/lists.html\n\n"+
"Red Hat mailing lists:\n"+
"    https://listman.redhat.com/mailman/listinfo";

var obsoleteRHELString = "This bug is filed against release of RHEL, which is in "+
"maintenance phase. During the maintenance phase, only security errata and "+
"select mission critical bug fixes will be released for enterprise "+
"products. Since this bug does not meet that criteria, it is now being "+
"closed.\n\nFor more information of the RHEL errata support policy, "+
"please visit:\n\nhttp://www.redhat.com/security/updates/errata/\n\n"+
"If you feel this bug is indeed mission critical, please contact your "+
"support representative. You may be asked to provide detailed "+
"information on how this bug is affecting you.";

//

var hashBugzillaName = Array();
var hashBugzillaWholeURL = Array();

hashBugzillaName['bugzilla.mozilla.org'] = "Mozilla Foundation";
hashBugzillaName['bugs.freedesktop.org'] = "FreeDesktop.org";

hashBugzillaWholeURL['6'] = "https://bugzilla.mozilla.org/show_bug.cgi?id=";
hashBugzillaWholeURL['11'] = "https://bugs.freedesktop.org/show_bug.cgi?id=";

/** Clean the string from spaces around
*
* @param string to be cleaned
* @return string which was cleaned
*
*/
function strip(str) {
   return str.replace(/^\s*(.*)\s*$/,"$1");
}

/** Check whether an item is member of the list. Idea is just to
 * make long if commands slightly more readable.
 *
 * @param mbr string to be searched in the list
 * @param list list
 * @return position of the string in the list, or -1 if none found.
 */
function isInList(mbr,list) {
		return (list.indexOf(mbr) !== -1);
}

/** Returns an element of the list for which lambda function is true.
 *
 * @param list array to be searched
 * @param function with the one element of the list as the sole
 * argument; returns true or false
 * @return object of the found element, or an empty object if none found.
 */
function pickElement(list,testFce) {
    var tempPickElement = {};
    for (var i=0; i<list.length; i++) {
    	tempPickElement = list[i];
		if (testFce(tempPickElement)) {
	    	return tempPickElement;
		}
    }
    return {};
}

/** Converts attributes value of the given list of elements to the
 *  Javascript list.
 *  @param list array of elements
 *  @return array of values
 */
function valuesToList(list) {
	var outL = [];
	var member = "";

	for (var i = 0; i < list.length; i++) {
    	if(list[i].hasAttribute("value")) {
			member = list[i].getAttribute("value");
			member = member.replace(/\s*(.*)\s*/,"$1");
			outL[outL.length] = member;
    	}
    }
    return outL;
}

/** Check whether an item is member of the list. Idea is just to
 * make long if commands slightly more readable.
 *
 * @param mbr string to be searched in the list
 * @param list list
 * @return position of the string in the list, or -1 if none found.
 */
function isInList(mbr,list) {
     return(list.indexOf(mbr) !== -1);
}

/* Bugzilla functions.*/

/** Find the next (or previous) sibling element of given tagName
 * starting from given element.
 *
 * @param startElement element from which to start searching
 * @param tagName string tagName of the searched for element (case insensitive)
 * @param forward boolean optional should we search forward or backward?
 * @return element of the given tagName or null
 */
function findNextSiblingByTagName(startElement,tagName,forward) {
	if (forward === null) { // missing optional argument
		forward = true;
	}
	var tempElement = startElement;
	tagName = tagName.toUpperCase();
	while (tempElement && tempElement.tagName != tagName) {
		if (forward) {
			tempElement = tempElement.nextSibling;
		} else {
			tempElement = tempElement.previousSibling;
		}
	}
	return tempElement;
}

/** Select option with given label on the <SELECT> element with given id.
 *
 * Also execute change HTMLEvent, so that the form behaves accordingly.
 *
 * @param id
 * @param label
 * @return none
 */
function selectOption(id,label) {
	var selectElement = document.getElementById(id);
	var values = selectElement.options;
	var option = pickElement(values,
	    function(x){
		    x.normalize();
		    return (x.text==label);
	    });
	option.selected = true;

	var intEvent = document.createEvent("HTMLEvents");
	intEvent.initEvent("change", true, true);
	selectElement.dispatchEvent(intEvent);
}

/** Returns the component of the bug
 *
 * @return string component of the bug
 */
function getComponent() {
	var compElement = document.getElementById("bz_component_edit_container");
	compElement.normalize();
	var compStr = compElement.textContent.replace(/\s+/g," ").split(" ")[1];
	return compStr;
}

/**
 *
 * @return bool if this bug is a gecko bug (and thus should get gecko-maint address)
 */
function isGeckoBug() {
	var component = getComponent();
	var RE = /epiphany.*|firefox|galeon|gecko-sharp2|htmlview|^mozilla|seamonkey|thunderbird|xulrunner/;
	return RE.test(component);
}

/** Returns owner of the bug.
 *
 * @return string with the email address of the assignee.
 */
function getAssignedTo() {
	var assigneeEditContainer = document.getElementById("bz_assignee_edit_container").getElementsByClassName("fn")[0];
	return assigneeEditContainer.textContent;
}

/** Returns reporter of the bug.
 *
 * @return string with the email address of the reporter.
 */
function getReporter() {
    var reportedSpanTag = document.getElementById("bz_show_bug_column_2").getElementsByClassName("fn")[0];
    return reportedSpanTag.textContent;
}

/** Returns the number of the current bug
 *
 * @return int with the bug number
 */
function getBugNo() {
	var title = strip(document.getElementById("title").getElementsByTagName("p")[0].innerHTML);
	var bugNo = eval(title.split("&nbsp;")[1]);
	return bugNo;
}

/** Returns list of people getting CC of all bug messages.
 *
 * @return array with the all members of the CC list.
 */
function getCCList() {
    var selectRef = document.getElementsByName("cc");
    if (selectRef.length>0) {
		return valuesToList(selectRef[0]);
    } else {
		return [];
    }
}

/** Add accesskey to the particular element
 *
 * @param rootElement element to which the new text object will be attached
 * @param beforeText text before the accesskey character
 * @param accKey what will be the accesskey itself
 * @param afterText text after the accesskey character
 * @return modified element with the fixed accesskey
 *
*/
function fixElement(rootElement,beforeText,accKey,afterText) {
    rootElement.setAttribute("accesskey",accKey.toLowerCase());
    rootElement.innerHTML = beforeText + "<b><u>" + accKey + "</u></b>" + afterText;
    return rootElement;
}

/** Generic function to add new button to the page.
 * Actually copies new button from the old one (in order to have the same
 * look-and-feel, etc.
 * @param originalLocation object with the button to be copied from
 * @param newId string with the id of the new button; has to be unique in
                whole page
 * @param newLabel string with the label which will be shown to user
 * @param handlerFunc function used as handler when the button is clicked on
 * @param doSubmit bool optional whether the button should submit whole page
 *              (default true)
 *
 * @return none
 */
function addNewButton(originalLocation,newId,newLabel,handlerFunc,doSubmit) {
	if (doSubmit === null) { // missing optional argument
		doSubmit = true;
	}
    var newButton = originalButton.cloneNode(true);
    if (!doSubmit) {
    	newButton.setAttribute("type","button");
    }
    newButton.id=newId;
    newButton.setAttribute("value",newLabel);
    newButton.addEventListener('click',handlerFunc,true);
    var textNode = document.createTextNode("\u00A0");
    originalLocation.parentNode.insertBefore(textNode,originalLocation);
    originalLocation.parentNode.insertBefore(newButton,textNode);
}

/** Add XGL maint to the CC list
 * @param evt event which made this function active
 *
 * @return none
 */
function changeOwnerHandler(evt) {
    /** Take care that when changing assignment of the bug,
     * current owner is added to CC list.
     * Switch off setting to the default assignee
     */
    if (!isInList(maintAddr, CCList)) {
		addToCC(maintAddr);
    }
    var setDefaultAssigneeCheckbox = document.getElementById("set_default_assignee");
    setDefaultAssigneeCheckbox.checked = false;
    selectOption("bug_status", "ASSIGNED");
}

/** Set the bug to NEEDINFO state
 *
 * Working function.
 * @return none
 */
function setNeedinfoReporter() {
    var checkbox = document.getElementById("needinfo");
    checkbox.checked = true;
    selectOption("needinfo_role", "reporter");
}

/** Set the bug to NEEDINFO state
 *
 * Handler to be called from the DOM event
 * @param evt event calling the handler
 * @return none
 */
function needinfoHandler(evt) {
    setNeedinfoReporter();
}

/** Set the bug to NEEDINFO state
 *
 * Working function.
 * @return none
 */
function setNeedinfoReporter() {
    var checkbox = document.getElementById("needinfo");
    checkbox.click();
    selectOption("needinfo_role", "reporter");
}

/** Set the bug to NEEDINFO state
 *
 * Handler to be called from the DOM event
 * @param evt event calling the handler
 * @return none
 */
function needinfoHandler(evt) {
    setNeedinfoReporter();
}

/** Add text to the comment.
 * @param string2BAdded string to be added to the comment box
 *
 * @return none
 */
function addTextToComment(string2BAdded) {
	var commentTextarea = document.getElementById("comment");

	// don't remove the current content of the comment box,
	// just behave accordingly
	if (commentTextarea.value.length > 0) {
		commentTextarea.value += "\n\n";
	}
	commentTextarea.value += string2BAdded;
}

/** add address to CC of this bug
 *
 * @param address string address to be added
 * @return none
 */
function addToCC(address) {
	var sel = document.getElementById("newcc");
	sel.value = address;
}

/** Add XGL maint to the CC list
 * @param evt event which made this function active
 *
 * @return none
 */
function addXGLmaintHandler(evt) {
    if (!isInList(maintAddr, CCList)) {
    	addToCC(maintAddr);
    }
    evt.stopPropagation();
    evt.preventDefault();
}

/** Add note, that there is nothing to triage and switch to ASSIGNED
 * @param evt event which called this handler
 *
 * @return none
 */
function addNoTriageStringHandler(evt) {
	addTextToComment(noTriageString);
    selectOption("bug_status", "ASSIGNED");
    document.getElementById("addselfcc").checked = true;
}

/** Add reminder to NEEDINFO threatening INSUFFICIENT_DATA if
 *  NEEDINFOee won't reply in a month.
 * @param evt event which called this handler
 *
 * @return none
 */
function addMoveYourButtHandler(evt) {
	addTextToComment(moveYourButString);
}

/** Add request for /etc/X11/xorg.conf and /var/log/Xorg.0.log to the comment
 * @param evt event which called this handler
 *
 * @return none
 */
function addGetXLogsBlahHandler(evt) {
	addTextToComment(getLogsString);
	setNeedinfoReporter();
}

/** Add request for /tmp/X* from the Live CD to the comment
 * @param evt event which called this handler
 *
 * @return none
 */
function addGetXLogsOnLiveCDHandler(evt) {
	addTextToComment(getLogsLiveCDString);
	setNeedinfoReporter();
}

/** Add request for filing the bug upstream, so that I could close it.
 * @param evt event which called this handler
 *
 * @return none
 */
function addSuicideNote(evt) {
	addTextToComment(getSuicideString);
	setNeedinfoReporter();
}

/** Add request for filing the bug into IssueTracker
 * @param evt event which called this handler
 *
 * @return none
 */
function addRHELNote(evt) {
	addTextToComment(RHELString);
	setNeedinfoReporter();
}

/** Return string with the ID for the external_id SELECT for
 * external bugzilla
 *
 * @param URLhostname string hostname of the external bugzilla
 * @return string with the string for the external_id SELECT
 */
function getBugzillaName(URLhostname) {
	var bugzillaID = "";
	if (hashBugzillaName[URLhostname]) {
	    bugzillaID = hashBugzillaName[URLhostname];
	} else {
	    bugzillaID = "";
	}
	return bugzillaID;
}

function getWholeURL(selectValue,bugID) {
	var returnURL = "";
	if (hashBugzillaWholeURL[selectValue]) {
	    returnURL = hashBugzillaWholeURL[selectValue]+bugID;
	} else {
	    returnURL = "";
	}
	return returnURL;
}

/** Add information about the upstream bug upstream, and closing it.
 * @param evt event which called this handler
 *
 * @return none
 */
function addClosingUpstream(evt) {
	var externalRefs = document.getElementById("external_bugs_table");
	var refs = externalRefs.getElementsByTagName("tr");
	// that's a bad id, if there is a one.
	var inputBox = document.getElementById("inputbox");

	// It is not good to close bug as UPSTREAM, if there is no reference
	// to the upstream bug.
	if ((refs.length > 2) || (inputBox.value.length > 0)) {
		addTextToComment(sentUpstreamString);
		selectOption("bug_status", "CLOSED");
		selectOption("resolution", "UPSTREAM");
	}
}

/** No response on NEEDINFO
 * @param evt event which called this handler
 *
 * @return none
 */
function addnoResponseNEEDINFO(evt) {
	addTextToComment(noResponseString);
	selectOption("bug_status", "CLOSED");
	selectOption("resolution", "INSUFFICIENT_DATA");
}

/** We don't like binary only nvidia drivers
 *
 * Enter to the comment box information for the reporter to make them unhappy
 * set bug to CLOSED/CANTFIX (but don't submit -- just to be sure)
 *
 * @param evt event which called this handler
 *
 * @return none
 */
function addCloseNvidiaDriver(evt) {
	addTextToComment(dieNvidiaDieDieDie);
	selectOption("bug_status", "CLOSED");
	selectOption("resolution", "CANTFIX");
}

/** We don't support archeological releases of RHEL that much
 *
 * Enter to the comment box information for the reporter and
 * set bug to CLOSED/WONTFIX (but don't submit -- just to be sure)
 *
 * @param evt event which called this handler
 *
 * @return none
 */
function addCloseObsoleteRHEL(evt) {
	addTextToComment(obsoleteRHELString);
	selectOption("bug_status", "CLOSED");
	selectOption("resolution", "WONTFIX");
}

/** Add request for debugging information for Firefox
 * @param evt event which called this handler
 *
 * @return none
 */
function addFirefoxDebugInfo(evt) {
	addTextToComment(getFirefoxBacktraceString);
	setNeedinfoReporter();
}

function swapXGLMainToCCListHandler(evt) {
    /** Remove mcepl@redhat.com from CC list and put there
     * xgl-maint@redhat.com
     */

	myAddrIndex = CCList.indexOf(myAddr);
	if (!isInList(maintAddr, CCList)) {
		addToCC(maintAddr);
	}
	if (isInList(myAddr, CCList)) {
		var selBox = document.getElementById("cc");
		selBox[myAddrIndex].selected = true;
		document.getElementById("removecc").checked = true;
	}
    evt.stopPropagation();
    evt.preventDefault();
}

var bugNo = getBugNo();
var reporter = getReporter();
var owner = getAssignedTo();
var CCList = getCCList();
var myAddr = "mcepl@redhat.com";
var XGLAddr = "xgl-maint@redhat.com";
var GeckoAddr = "gecko-bugs-nobody@fedoraproject.org";
var maintAddr = XGLAddr;

if (isGeckoBug()) {
	maintAddr = GeckoAddr;
}

// we should make visible whether maintAddr is in CCList
//
//Pitfall #10: style
//
//In JavaScript, every element has a style attribute, with which you can get and
//set the element's CSS styles. Firefox also supports a shorthand method for setting multiple styles at once:
//
//var elmFoo = document.getElementById("foo");
//elmFoo.setAttribute("style", "margin:0; padding:0;");
//
//This does not work in Greasemonkey scripts, because the object returned by
//document.getElementById is an XPCNativeWrapper, and XPCNativeWrappers do not
//support this shorthand for setting CSS styles in bulk. You will need to set each style individually:
//
//var elmFoo = document.getElementById("foo");
//elmFoo.style.margin = 0;
//elmFoo.style.padding = 0;
//
// and family-style properties are defined in JavaScript as familyStyle.
if (isInList(maintAddr, CCList)) {
	var switchCCEdit=document.getElementById("cc_edit_area_showhide");
	//switchCCEdit.textContent = "*"+switchCCEdit.textContent;
	switchCCEdit.style.color = "navy";
	switchCCEdit.style.fontWeight = "bolder";
	switchCCEdit.style.textDecoration = "underline";
}

// Generate a list of <input> elements in the page
var IBList = [];
var IBRawList = document.getElementsByTagName("input");
for (var i=0;i<IBRawList.length;i++) {
    if ((IBRawList[i].hasAttribute("type")) &&
    	(IBRawList[i].getAttribute("type")=="submit")) {
		IBList = IBList.concat(IBRawList[i]);
    }
}

var divKnobButtons = document.getElementById("knob-buttons");
var IBUnderTextBox = divKnobButtons.getElementsByTagName("input")[0];

var originalButton = IBUnderTextBox; // source button to be copied from
originalButton.setAttribute("accesskey",'s');
originalButton.setAttribute("value","Submit");

// Just for fixing wrong CC list
if (isInList(myAddr,CCList) && !isInList(XGLAddr,CCList)) {
    addNewButton(IBList[1],"swapXGLMainToCCList","Swap -maint to CC",
		 swapXGLMainToCCListHandler);
}

// BUTTONS ON THE BOTTOM OF THE FORM
// Create a new SUBMIT button adding current owner of the bug to
// the CC list
var IBLast = IBList[IBList.length-4];
addNewButton(IBLast,"changeOwnerbtn","reASSIGN",
	     changeOwnerHandler);
// Create another new SUBMIT button which just adds xgl-maint to
// CC list
addNewButton(IBLast,"addxglplain","Add -maint to CC list",
	     addXGLmaintHandler);

// BUTTONS ABOVE THE COMMENT BOX
var textCommentElement = document.getElementById("comment");
var brElement = findNextSiblingByTagName(textCommentElement,"BR",false);
var insertAfterElement = brElement.nextSibling;
// Add "Please add /etc/X11/... " to the textform
addNewButton(insertAfterElement,"addgetlogstext","X logs",
	     addGetXLogsBlahHandler,false);
// Add request for firefox debugging infor to the textform
addNewButton(insertAfterElement,"addgetffbtrace","FF btrace",
	     addFirefoxDebugInfo,false);
// Add a "suicide" NEEDINFO
addNewButton(insertAfterElement,"addgetsuicide","Suicide",
	     addSuicideNote,false);
// Add a no response closing string
addNewButton(insertAfterElement,"addnoresponse","No Response",
	     addnoResponseNEEDINFO,false);
// Add a "don't laugh at NEEDINFO" reminder
addNewButton(insertAfterElement,"moveyourbutt","Info Reminder",
	     addMoveYourButtHandler,false);
// Close nvidia binary only bug
addNewButton(insertAfterElement,"closenvidia","nVidia",
	     addCloseNvidiaDriver,false);

// Add BR element after the line of buttons
var newBRElement = document.createElement("BR");
var parElement = textCommentElement.parentNode;
parElement.insertBefore(newBRElement,textCommentElement);
newBRElement.style.fontSize = "200%";
newBRElement.style.clear = "all";
newBRElement.style.marginBottom = "0.25ex";

// BUTTONS BELOW THE COMMENT BOX
// Add a "suicide" NEEDINFO
addNewButton(IBUnderTextBox,"addcloseupstream","Close UPSTREAM",
	     addClosingUpstream,false);
// Create another new SUBMIT button which sets NEEDINFO(reporter)
addNewButton(IBUnderTextBox,"needinforbtn","NEEDINFO (reporter)",
	     needinfoHandler,false);
// nothing to be triaged
addNewButton(IBUnderTextBox,"notriagebtn","no Triage",
	     addNoTriageStringHandler,false);
// Live CD logs
addNewButton(IBUnderTextBox,"xloglivecdbtn","Live CD logs",
	     addGetXLogsOnLiveCDHandler,false);

// Move new status button under allow line
//var statusDiv = document.getElementById("status");
//parElement = statusDiv.parentNode;
//parElement.insertBefore(newBRElement.cloneNode(true),statusDiv)
//divKnobButtons.normalize();
//divKnobButtons.appendChild(newBRElement.cloneNode(true));
//divKnobButtons.appendChild(statusDiv);